static const char *terminal[]         = { "st", NULL };
static const char *ranger[]           = { "st", "-e", "ranger", NULL };
static const char *neomutt[]          = { "st", "-e", "neomutt", NULL };
static const char *newsboat[]         = { "st", "-e", "newsboat", NULL };
static const char *vim[]              = { "st", "-e", "vim", NULL };
static const char *calcurse[]         = { "shed", NULL };
static const char *todo[]             = { "todo", NULL };
static const char *ncmpcpp[]          = { "st", "-e", "ncmpcpp", NULL };
static const char *surf[]             = { "surf", "-d", "-m", "https://start.duckduckgo.com", NULL };
static const char *firefox[]          = { "firefox", "--private", NULL };
static const char *mpctoggle[]        = { "lmc", "toggle", NULL };
static const char *mpcstop[]          = { "mpc", "stop", NULL };
static const char *next[]             = { "lmc", "next", NULL };
static const char *prev[]             = { "lmc", "prev", NULL };
static const char *forward[]          = { "lmc", "forward", "10", NULL };
static const char *back[]             = { "lmc", "back", "10", NULL };
static const char *mute[]             = { "lmc", "mute", NULL };
static const char *volup[]            = { "lmc", "up", "5", NULL };
static const char *voldown[]          = { "lmc", "down", "5", NULL };
static const char *syncup[]           = { "syncworkflow", "up", NULL };
static const char *syncdown[]         = { "syncworkflow", "down", NULL };
static const char *search[]           = { "search", NULL };
static const char *handle[]           = { "handle", NULL };
static const char *contacts[]         = { "contacts", NULL };
static const char *emojis[]           = { "emojis", NULL };
static const char *camtoggle[]        = { "camtoggle", NULL };
static const char *helpmenu[]         = { "helpmenu", NULL };
static const char *config[]           = { "config", NULL };
static const char *backup[]           = { "backup", NULL };
static const char *publish[]          = { "publish", NULL };
static const char *netmenu[]          = { "netmenu", NULL };
static const char *bm[]               = { "bm", NULL };
static const char *umountmenu[]       = { "umountmenu", NULL };
static const char *mountmenu[]        = { "mountmenu", NULL };
static const char *gotourl[]          = { "gotourl", NULL };
static const char *record[]           = { "record", NULL };
static const char *recordkill[]       = { "record", "kill", NULL };
static const char *autoprintscreen[]  = { "printscreen", "auto", NULL };
static const char *printscreen[]      = { "printscreen", NULL };
static const char *screenkey[]        = { "toggle", "screenkey", NULL };
static const char *screenset[]        = { "screen", NULL };
static const char *pics[]             = { "pics", NULL };
static const char *lock[]             = { "lock", NULL };

static Key keys[] = {
	/* modifier                     key              function        argument */
	{ MODKEY,                       XK_Print,        spawn,          {.v = printscreen } },
	{ 0,                            XK_Print,        spawn,          {.v = autoprintscreen } },
	{ MODKEY|ShiftMask,             XK_Print,        spawn,          {.v = screenkey } },
	{ MODKEY,                       XK_Return,       spawn,          {.v = terminal } },
	{ MODKEY|ShiftMask,             XK_Return,       zoom,           {0} },
	{ MODKEY,                       XK_F1,           spawn,          {.v = helpmenu } },
	{ MODKEY,                       XK_F2,           spawn,          {.v = config } },
	{ MODKEY,                       XK_F3,           spawn,          {.v = umountmenu } },
	{ MODKEY|ShiftMask,             XK_F3,           spawn,          {.v = mountmenu } },
	{ MODKEY,                       XK_q,            killclient,     {0} },
	{ MODKEY|ShiftMask,             XK_q,            killclient,     {0} },
	{ MODKEY,                       XK_w,            spawn,          {.v = surf } },
	{ MODKEY|ShiftMask,             XK_w,            spawn,          {.v = firefox } },
	{ MODKEY,                       XK_e,            spawn,          {.v = ranger } },
	{ MODKEY|ShiftMask,             XK_e,            spawn,          {.v = neomutt } },
	{ MODKEY,                       XK_r,            spawn,          {.v = dmenucmd } },
	{ MODKEY|ShiftMask,             XK_r,            spawn,          {.v = sudmenucmd } },
	{ MODKEY,                       XK_t,            setlayout,      {.v = &layouts[1]} },
	{ MODKEY|ShiftMask,             XK_t,            setlayout,      {.v = &layouts[2]} },
	{ MODKEY,                       XK_y,            spawn,          {.v = handle } },
	{ MODKEY,                       XK_i,            spawn,          {.v = newsboat } },
	{ MODKEY|ShiftMask,             XK_i,            incnmaster,     {.i = +1 } },
	{ MODKEY|ShiftMask,             XK_o,            incnmaster,     {.i = -1 } },
	{ MODKEY,                       XK_p,            spawn,          {.v = mpctoggle } },
	{ MODKEY|ShiftMask,             XK_p,            spawn,          {.v = pics } },
	{ MODKEY,                       XK_s,            spawn,          {.v = search } },
	{ MODKEY,                       XK_f,            setlayout,      {.v = &layouts[3]} },
	{ MODKEY|ShiftMask,             XK_f,            setlayout,      {.v = &layouts[0]} },
	{ MODKEY,                       XK_g,            spawn,          {.v = gotourl } },
	{ MODKEY,                       XK_h,            setmfact,       {.f = -0.05} },
	{ MODKEY,                       XK_j,            focusstack,     {.i = +1 } },
	{ MODKEY|ShiftMask,             XK_j,            movestack,      {.i = +1 } },
	{ MODKEY,                       XK_k,            focusstack,     {.i = -1 } },
	{ MODKEY|ShiftMask,             XK_k,            movestack,      {.i = -1 } },
	{ MODKEY,                       XK_l,            setmfact,       {.f = +0.05} },
	{ MODKEY,                       XK_z,            togglebar,      {0} },
	{ MODKEY,                       XK_x,            spawn,          {.v = lock } },
	{ MODKEY|ShiftMask,             XK_x,            spawn,          {.v = lock } },
	{ MODKEY,                       XK_c,            spawn,          {.v = calcurse } },
	{ MODKEY|ShiftMask,             XK_c,            spawn,          {.v = contacts } },
	{ MODKEY,                       XK_v,            spawn,          {.v = vim } },
	{ MODKEY|ShiftMask,             XK_v,            spawn,          {.v = camtoggle } },
	{ MODKEY,                       XK_b,            spawn,          {.v = bm } },
	{ MODKEY,                       XK_n,            spawn,          {.v = netmenu } },
	{ MODKEY|ShiftMask,             XK_n,            spawn,          {.v = todo } },
	{ MODKEY,                       XK_m,            spawn,          {.v = ncmpcpp } },
	{ MODKEY|ShiftMask,             XK_m,            spawn,          {.v = mute } },
	{ MODKEY,                       XK_BackSpace,    spawn,          {.v = backup } },
	{ MODKEY|ShiftMask,             XK_BackSpace,    spawn,          {.v = publish } },
	{ MODKEY,                       XK_Insert,       spawn,          {.v = record } },
	{ MODKEY,                       XK_Delete,       spawn,          {.v = recordkill } },
	{ MODKEY,                       XK_Up,           spawn,          {.v = syncup } },
	{ MODKEY,                       XK_Down,         spawn,          {.v = syncdown } },
	{ MODKEY,                       XK_Escape,       shiftview,      {.i = -1 } },
	{ MODKEY|ShiftMask,             XK_Escape,       quit,           {0} },
	{ MODKEY,                       XK_grave,        shiftview,      {.i = 1 } },
	{ MODKEY|ShiftMask,             XK_grave,        spawn,          {.v = emojis } },
	{ MODKEY,                       XK_minus,        spawn,          {.v = voldown } },
	{ MODKEY,                       XK_equal,        spawn,          {.v = volup } },
	{ MODKEY,                       XK_bracketleft,  spawn,          {.v = prev } },
	{ MODKEY|ShiftMask,             XK_bracketleft,  spawn,          {.v = back } },
	{ MODKEY,                       XK_bracketright, spawn,          {.v = next } },
	{ MODKEY|ShiftMask,             XK_bracketright, spawn,          {.v = forward } },
	{ MODKEY,                       XK_Tab,          view,           {0} },
	{ MODKEY,                       XK_space,        setlayout,      {0} },
	{ MODKEY|ShiftMask,             XK_space,        togglefloating, {0} },
	{ MODKEY,                       XK_comma,        focusmon,       {.i = -1 } },
	{ MODKEY|ShiftMask,             XK_comma,        tagmon,         {.i = -1 } },
	{ MODKEY,                       XK_period,       focusmon,       {.i = +1 } },
	{ MODKEY|ShiftMask,             XK_period,       tagmon,         {.i = +1 } },
	{ MODKEY,                       XK_0,            view,           {.ui = ~0 } },
	{ MODKEY|ShiftMask,             XK_0,            tag,            {.ui = ~0 } },
        { 0,                            0x1008ff11,      spawn,          {.v = voldown } },
        { 0,                            0x1008ff12,      spawn,          {.v = mute } },
        { 0,                            0x1008ff13,      spawn,          {.v = volup } },
        { 0,                            0x1008ff2d,      spawn,          {.v = lock } },
        { 0,                            0x1008ff8f,      spawn,          {.v = camtoggle } },
        { 0,                            0x1008ff59,      spawn,          {.v = screenset } },
        { 0,                            0x1008ff14,      spawn,          {.v = mpctoggle } },
        { 0,                            0x1008ff15,      spawn,          {.v = mpcstop } },
        { 0,                            0x1008ff17,      spawn,          {.v = next } },
        { 0,                            0x1008ff16,      spawn,          {.v = prev } },
	TAGKEYS(                        XK_1,                      0)
	TAGKEYS(                        XK_2,                      1)
	TAGKEYS(                        XK_3,                      2)
	TAGKEYS(                        XK_4,                      3)
	TAGKEYS(                        XK_5,                      4)
	TAGKEYS(                        XK_6,                      5)
	TAGKEYS(                        XK_7,                      6)
	TAGKEYS(                        XK_8,                      7)
	TAGKEYS(                        XK_9,                      8)
};
